package com.greenorange.promotion.model.dto;

import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotEmpty;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.util.List;

@Data
@Schema(description = "参数:id列表", requiredProperties = {"ids"})
public class CommonBatchRequest implements Serializable {


    @NotEmpty(message = "id列表不能为空")
    @Schema(description = "id列表", example = "[1, 2, 3]")
    private List<Long> ids;


    @Serial
    private static final long serialVersionUID = 1L;
}
