package com.greenorange.promotion.model.dto;

import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;

@Data
@Schema(description = "参数:id", requiredProperties = {"id"})
public class CommonRequest implements Serializable {

    /**
     * id
     */
    @NotNull(message = "id不能为null")
    @Min(value = 1L, message = "id不能小于1")
    @Schema(description = "id", example = "1")
    private Long id;

    @Serial
    private static final long serialVersionUID = 1L;
}
