package com.greenorange.promotion.model.dto.projectCommission;

import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.Min;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.math.BigDecimal;

@Data
public class ProjectCommissionUniteUpdateRequest implements Serializable {

    /**
     * 统一抽佣比例
     */
    @Min(value = 0L, message = "抽佣比例不能小于0")
    @Schema(description = "统一抽佣比例", example = "5")
    private BigDecimal uniteCommissionRate;


    @Serial
    private static final long serialVersionUID = 1L;

}
