package com.greenorange.promotion.model.dto.withdrawalApply;

import com.greenorange.promotion.annotation.WithdrawStatusEnumValue;
import com.greenorange.promotion.model.enums.WithdrawStatusEnum;
import io.swagger.v3.oas.annotations.media.Schema;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.Min;
import lombok.Data;
import java.math.BigDecimal;

import java.io.Serial;
import java.io.Serializable;

/**
 * 提现申请记录添加请求体
 */
@Data
@Schema(description = "提现申请记录添加请求体", requiredProperties = {
                "withdrawnAmount",
                "withdrawalStatus",
                "userId",
})
public class WithdrawalApplyAddRequest implements Serializable {

    /**
     * 提现金额
     */
    @Schema(description = "提现金额", example = "1.00")
    private BigDecimal withdrawnAmount;


    @Serial
    private static final long serialVersionUID = 1L;
}

