package com.greenorange.promotion.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import jakarta.validation.constraints.NotBlank;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 资金变动记录表
 * @TableName funds_change
 */
@TableName(value ="funds_change")
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class FundsChange implements Serializable {
    /**
     * 资金变动ID
     */
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 项目名称
     */
    private String projectName;

    /**
     * 变动金额
     */
    private BigDecimal changeAmount;

    /**
     * 当前金额（变动后的总金额）
     */
    private BigDecimal currentAmount;

    /**
     * 用户ID
     */
    private Long userId;

    /**
     * 项目结算记录id
     */
    private Long projectSettlementId;

    /**
     * 是否删除
     */
    private Integer isDelete;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}