package com.greenorange.promotion.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 项目结算记录表
 * @TableName project_settlement
 */
@TableName(value ="project_settlement")
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class ProjectSettlement implements Serializable {
    /**
     * 结算记录ID
     */
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 项目明细名称
     */
    private String projectDetailName;

    /**
     * 结算数量
     */
    private Integer settlementQuantity;

    /**
     * 结算收益
     */
    private BigDecimal settlementRevenue;

    /**
     * 作业时间
     */
    private Date workTime;

    /**
     * 结算时间
     */
    private Date settlementTime;

    /**
     * 推广码申请记录id
     */
    private Long promoCodeApplyId;

    /**
     * 收益来源（true:抽成，false：推广码）
     */
    private Boolean revenueSource;

    /**
     * 项目id
     */
    private Long projectId;

    /**
     * 项目明细id
     */
    private Long projectDetailId;

    /**
     * 上级结算记录id
     */
    private Long superId;

    /**
     * 用户id
     */
    private Long userId;

    /**
     * 是否删除
     */
    private Integer isDelete;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}