package com.greenorange.promotion.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 推广码申请记录表
 * @TableName promo_code_apply
 */
@TableName(value ="promo_code_apply")
@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class PromoCodeApply implements Serializable {
    /**
     * 推广码申请ID
     */
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 业务员姓名
     */
    private String salespersonName;

    /**
     * 业务员手机号
     */
    private String salespersonPhone;

    /**
     * 绑定的推广码信息key
     */
    private String promoCodeInfoKey;

    /**
     * 绑定的推广码链接
     */
    private String promoCodeLink;

    /**
     * 推广码图片
     */
    private String promoCodeImage;

    /**
     * 项目id
     */
    private Long projectId;

    /**
     * 绑定的项目名称
     */
    private String projectName;

    /**
     * 绑定的项目图片URL
     */
    private String projectImage;

    /**
     * 用户ID
     */
    private Long userId;

    /**
     * 是否删除
     */
    private Integer isDelete;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}