package com.greenorange.promotion.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;

/**
 * 下级用户项目明细抽佣表
 * @TableName sub_user_project_commission
 */
@TableName(value ="sub_user_project_commission")
@Data
public class SubUserProjectCommission implements Serializable {
    /**
     * 下级用户抽佣记录ID
     */
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 项目明细ID
     */
    private Long projectDetailId;

    /**
     * 我的单价
     */
    private BigDecimal myUnitPrice;

    /**
     * 当前抽佣比例
     */
    private BigDecimal currentCommissionRate;

    /**
     * 下级用户ID
     */
    private Long subUserId;

    /**
     * 项目ID
     */
    private Long projectId;

    /**
     * 用户ID
     */
    private Long userId;

    /**
     * 是否删除
     */
    private Integer isDelete;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}