package com.greenorange.promotion.model.vo.fileInfo;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 文件 视图对象
 */
@Data
@Schema(description = "文件 视图对象")
public class FileInfoVO implements Serializable {

    /**
     * 文件ID
     */
    @Schema(description = "文件ID", example = "1")
    private Long id;

    /**
     * 文件名
     */
    @Schema(description = "文件名", example = "file.png")
    private String name;

    /**
     * 文件类型
     */
    @Schema(description = "文件类型", example = "png")
    private String type;

    /**
     * 文件大小(KB)
     */
    @Schema(description = "文件大小", example = "3000")
    private Double size;

    /**
     * 文件view值
     */
    @Schema(description = "文件view值", example = "3E8U3A")
    private String fileView;

    /**
     * 文件业务类型[头像(avatar)|项目(project)|富文本(richText)|默认(default))]
     */
    @Schema(description = "文件业务类型[头像(avatar)|项目(project)|富文本(richText)|默认(default))]", example = "default")
    private String biz;

    /**
     * 文件hash值
     */
    @Schema(description = "文件hash值", example = "3E8U3A")
    private String hashValue;


    @Serial
    private static final long serialVersionUID = 1L;
}
