package com.greenorange.promotion.model.vo.projectDetail;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 项目明细 视图对象
 */
@Data
@Schema(description = "项目明细 视图对象")
public class ProjectDetailVO implements Serializable {

    /**
     * 项目明细ID
     */
    @Schema(description = "项目明细ID", example = "1")
    private Long id;

    /**
     * 项目明细名称
     */
    @Schema(description = "项目明细名称", example = "2.9元购买30元券包")
    private String projectDetailName;

    /**
     * 项目结算价
     */
    @Schema(description = "项目结算价", example = "0.72")
    private BigDecimal projectSettlementPrice;


    /**
     * 项目最小结算价格
     */
    @Schema(description = "项目最小结算价格", example = "0.66")
    private BigDecimal projectMinSettlementPrice;


    /**
     * 最大抽佣比例
     */
    @Schema(description = "最大抽佣比例", example = "2")
    private BigDecimal maxCommissionRate;

    /**
     * 项目ID
     */
    @Schema(description = "项目ID", example = "1")
    private Long projectId;


    @Serial
    private static final long serialVersionUID = 1L;
}
